/*****************************************************************************
* Lien Mp3 Player is an audio CD and mp3 player for GNU/Linux                *
* Copyright (C) 2007 Tan Chee Kien. See file COPYING for licence details     *
*                                                                            *
*    This program is free software; you can redistribute it and/or modify    *
*    it under the terms of the GNU General Public License as published by    *
*    the Free Software Foundation; either version 2 of the License, or       *
*    any later version.                                                      *
*                                                                            *
*    This program is distributed in the hope that it will be useful,         *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
*    GNU General Public License for more details.                            *
*                                                                            *
*    You should have received a copy of the GNU General Public License       *
*    along with this program; if not, write to the Free Software             *
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307    *  
*    USA                                                                     *
*                                                                            *
*    You can contact the author by sending an email to :                     *
*       gogota321@yahoo.com                                                  *
*****************************************************************************/

#define _GNU_SOURCE
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <fnmatch.h>
#include "lmp3.h"

void print_filename (char *filename, FILE * playlist);


void
big_select_all (char *start_path, FILE * playlist)
{
  char *f_name;
  DIR *pika;
  struct dirent *shit;
  struct stat abc;
  FILE *tmp_file;

  f_name = lmp3_tempnam ();
  chdir (start_path);

  tmp_file = fopen (f_name, "w");
  pika = opendir (start_path);

  while ((shit = readdir (pika)) != NULL)
    {
      //printf("%s\n",shit->d_name);
      stat (shit->d_name, &abc);
      if ((S_ISDIR (abc.st_mode) == 1)
	  && (strcmp (shit->d_name, ".") != 0)
	  && (strcmp (shit->d_name, "..") != 0)
	  && (strcmp (shit->d_name, "dev") != 0)
	  && (strcmp (shit->d_name, "proc") != 0))
	{
	  if (strcmp (start_path, "/") == 0)
	    fprintf (tmp_file, "%s%s\n", start_path, shit->d_name);
	  else
	    fprintf (tmp_file, "%s/%s\n", start_path, shit->d_name);
	  printf ("%s\n", shit->d_name);
	  //totaldir++;
	}
      else if (((fnmatch ("*p3", shit->d_name, 0) == 0)
		|| (fnmatch ("*P3", shit->d_name, 0) == 0)) &&
	       (strcmp (shit->d_name, "lmp3") != 0))
	{
	  fprintf (playlist, "%s\n%s\n", start_path, shit->d_name);
	  printf ("found %s\n", shit->d_name);
	}
    }
  fclose (tmp_file);
  //unlink (tmp_file);
  print_filename (f_name, playlist);
  unlink (f_name);
  delete_temp_file ();

}


void
print_filename (char *filename, FILE * playlist)
{

  char dirname[1000];
  DIR *pika;
  struct dirent *shit;
  struct stat abc;
  FILE *source;
  FILE *tmp_file;
  char *temp_file;
  int totaldir = 0;
//   char cwd[100];
  char fullpath[1000];
  char junk[10];

  source = fopen (filename, "r");
  temp_file = lmp3_tempnam ();
  tmp_file = fopen (temp_file, "w");
  //getcwd(cwd,99);

  while (1)
    {
      if (fscanf (source, "%[^\n]", dirname) != 1)
	break;
      printf ("Entering directory %s\n", dirname);
      fscanf (source, "%[\n]", junk);
      // getchar();
      if ((pika = opendir (dirname)) != NULL)
	{
	  while ((shit = readdir (pika)) != NULL)
	    {
	      //printf("%s\n",shit->d_name);
	      sprintf (fullpath, "%s/%s", dirname, shit->d_name);
	      stat (fullpath, &abc);
	      if ((S_ISDIR (abc.st_mode) == 1)
		  && (strcmp (shit->d_name, ".") != 0)
		  && (strcmp (shit->d_name, "..") != 0)
		  && (strcmp (shit->d_name, "dev") != 0)
		  && (strcmp (shit->d_name, "proc") != 0))
		{
		  fprintf (tmp_file, "%s/%s\n", dirname, shit->d_name);
		  printf ("%s\n", shit->d_name);
		  totaldir++;
		}
	      else if (((fnmatch ("*p3", shit->d_name, 0) == 0)
			|| (fnmatch ("*P3", shit->d_name, 0) == 0))
		       && (strcmp (shit->d_name, "lmp3") != 0))
		{
		  fprintf (playlist, "%s\n%s\n", dirname, shit->d_name);
		  printf ("found %s\n", shit->d_name);
		}
	    }
	  closedir (pika);
	}

    }
  fclose (source);
  fclose (tmp_file);
  if (totaldir != 0)
    print_filename (temp_file, playlist);
  unlink (temp_file);
}
