#include <unistd.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <stdlib.h>
#include "lmp3.h"

void
delete_temp_file (void)
{
  char tempdir[30];

  sprintf (tempdir, "%s/lmp3_tmp", gethome ());
  remove (tempdir);
}

char *
lmp3_tempnam (void)
{
  char tempdir[30];
  char filename[20];
  char *fullname;

  fullname = (char *) malloc (40 * sizeof (char));


  sprintf (tempdir, "%s/lmp3_tmp", gethome ());
  mkdir (tempdir, S_IRUSR | S_IWUSR | S_IXUSR);
  while (TRUE)
    {
      sprintf (filename, "%d.tmp", giverand (4000));
      sprintf (fullname, "%s/%s", tempdir, filename);
      if (stat (fullname, NULL) != 0)
	break;
    }
  return fullname;
}
